//
//  AmountCondition.m
//  iBal2
//
//  Created by Ken Kawamoto on Thu Aug 26 2004.
//  Copyright (c) 2004 AngryFish. All rights reserved.
//

#import "AmountCondition.h"
#import "IO.h"
#import "AmountConditionView.h"

@implementation AmountCondition

//アーカイブから初期化
- (id)initWithCoder:(NSCoder *)coder{
	[super initWithCoder:coder];
	
	return self;
}
//アーカイブにエンコード
- (void)encodeWithCoder:(NSCoder *)coder{
	[super encodeWithCoder:coder];
}


//IO matches condition
- (BOOL)ioMatchesCondition:(IO *)record{
	switch([super conditionTypeCode]){
		case kCondition_is:
		case kCondition_isnt:
		case kCondition_biggerThan:
		case kCondition_smallerThan:
		case kCondition_between:
		case kCondition_notBetween:
			return [super standardComparison:[record amount]];
	}
	return YES;
}

- (ConditionView *)conditionView{
	AmountConditionView *newView=[[AmountConditionView alloc]init];
	
	//set the what ID
	[newView setWhatToID:conditionTypeCode];

	switch(conditionTypeCode){
		case kCondition_between:
		case kCondition_notBetween:
			[[newView amountFieldUpperLimit]setObjectValue:object2];
		default:
			[[newView amountField]setObjectValue:object];
	}
	
	[newView sizeToFit];
	
	return newView;
}

@end
