//
//  AndConditions.m
//  iBal2
//
//  Created by Ken Kawamoto on Thu Aug 26 2004.
//  Copyright (c) 2004 AngryFish. All rights reserved.
//

#import "AndConditions.h"
#import "IO.h"
#import "Book.h"
#import "AndConditionView.h"

@implementation AndConditions

- (id)init{
	self=[super init];
	
	conditions=[[NSMutableArray alloc]init];
	
	return self;
}

//アーカイブから初期化
- (id)initWithCoder:(NSCoder *)coder{
	[super initWithCoder:coder];
	conditions=[[coder decodeObject]retain];
	
	return self;
}
//アーカイブにエンコード
- (void)encodeWithCoder:(NSCoder *)coder{
	[super encodeWithCoder:coder];
	[coder encodeObject:conditions];
}

- (void)addCondition:(Condition *)newCondition{
	[conditions addObject:newCondition];
}

- (NSMutableArray *)children{
	return conditions;
}

- (Book *)getBook{
	Book *temp=nil;
	int i,max=[conditions count]-1;
	for(i=0;i<=max;i++)
		if((temp=[[conditions objectAtIndex:i]getBook])!=nil)
			return temp;
	return nil;
}

- (AndConditions *)copy{
	AndConditions *newCond=[[AndConditions alloc]initWithCondition:self];
	int i,max=[conditions count]-1;
	for(i=0;i<=max;i++)
		[newCond addCondition:[conditions objectAtIndex:i]];
	return newCond;
}

//IO matches condition (returns true if all conditions are true)
- (BOOL)ioMatchesCondition:(IO *)record{
	int i,max=[conditions count]-1;
	for(i=0;i<=max;i++)
		if(![[conditions objectAtIndex:i]ioMatchesCondition:record])
			return NO;
	return YES;
}


- (ConditionView *)conditionView{
	AndConditionView *newView=[[AndConditionView alloc]init];
	int i,max=[conditions count]-1;
	for(i=0;i<=max;i++)
		[newView addSubview:[[conditions objectAtIndex:i]conditionView] withDraw:YES];
	return newView;
}

@end
