//
//  CommentCondition.m
//  iBal2
//
//  Created by Ken Kawamoto on Thu Aug 26 2004.
//  Copyright (c) 2004 AngryFish. All rights reserved.
//

#import "CommentCondition.h"
#import "IO.h"
#import "CommentConditionView.h"

@implementation CommentCondition

//アーカイブから初期化
- (id)initWithCoder:(NSCoder *)coder{
	[super initWithCoder:coder];
	
	return self;
}
//アーカイブにエンコード
- (void)encodeWithCoder:(NSCoder *)coder{
	[super encodeWithCoder:coder];
}


//IO matches condition
- (BOOL)ioMatchesCondition:(IO *)record{
	switch([super conditionTypeCode]){
		case kCondition_is:
		case kCondition_isnt:
			return [super standardComparison:[record amount]];
		case kCondition_includes:
			return [self checkIncludes:record];
		case kCondition_notInclude:
			return ![self checkIncludes:record];
		case kCondition_startsWith:
			return [self checkStartsWith:record];
		case kCondition_notStartWith:
			return ![self checkStartsWith:record];
		case kCondition_endsWith:
			return [self checkEndsWith:record];
		case kCondition_notEndWith:
			return ![self checkEndsWith:record];
	}
	return YES;
}

- (BOOL)checkIncludes:(IO *)record{
	NSRange range=[[record comment]rangeOfString:[super object]];
	return range.location!=NSNotFound;
}

- (BOOL)checkStartsWith:(IO *)record{
	NSRange range=[[record comment]rangeOfString:[super object]];
	return range.location==0;
}

- (BOOL)checkEndsWith:(IO *)record{
	NSString *comment=[record comment];
	return [[comment substringFromIndex:([comment length]-[object length])]isEqual:object];
}


- (ConditionView *)conditionView{
	CommentConditionView *newView=[[CommentConditionView alloc]init];
	
	//set the what ID
	[newView setWhatToID:conditionTypeCode];
	
	[[newView commentField]setObjectValue:object];
	
	[newView sizeToFit];
	return newView;
}

@end
