//
//  Condition.h
//  iBal2
//
//  Created by Ken Kawamoto on Thu Aug 05 2004.
//  Copyright (c) 2004 AngryFish. All rights reserved.
//

#import <Foundation/Foundation.h>

@class IO;
@class Book;
@class ConditionView;

enum IOConditionConstants{
	kCondition_is=1, //次の項目
	kCondition_isnt, //次ではない項目
	kCondition_biggerThan, //次より大きい項目 (次の日付以後の項目）
	kCondition_smallerThan, //次より小さい項目 （次の日付以前の項目）
	kCondition_between, //次の範囲の項目
	kCondition_notBetween, //次の範囲ではない項目
	kCondition_includes, //次を含む項目
	kCondition_notInclude, //次を含まない項目
	kCondition_startsWith, //次で始まる項目
	kCondition_notStartWith, //次で始まらない項目
	kCondition_endsWith, //次で終わる項目
	kCondition_notEndWith, //次で終わらない項目
	kCondition_inPeriod, //次の期間内の項目
	kCondition_notInPeriod //次の期間内ではない項目
};

@interface Condition : NSObject <NSCoding> {
	int conditionTypeCode;
	id object,object2;
}

- (id)init;
- (id)initWithCondition:(Condition *)anotherCondition;

//アーカイブから初期化
- (id)initWithCoder:(NSCoder *)coder;
//アーカイブにエンコード
- (void)encodeWithCoder:(NSCoder *)coder;

//accessors
- (void)setConditionTypeCode:(int)newConditionTypeCode;
- (int)conditionTypeCode;
- (void)setObject:(id)newObject;
- (id)object;
- (void)setObject2:(id)newObject2;
- (id)object2;

- (Condition *)copy;

//just get any book the smart book can be based on
- (Book *)getBook;

//IO matches condition
- (BOOL)ioMatchesCondition:(IO *)record;

- (BOOL)standardComparison:(id)recordObject;

- (ConditionView *)conditionView;

@end
