//
//  Condition.m
//  iBal2
//
//  Created by Ken Kawamoto on Thu Aug 05 2004.
//  Copyright (c) 2004 AngryFish. All rights reserved.
//

#import "Condition.h"
#import "IO.h"
#import "Book.h"
#import "ConditionView.h"

@implementation Condition

- (id)init{
	self=[super init];
	
	object=object2=nil;
	conditionTypeCode=0;
	
	return self;
}

- (id)initWithCondition:(Condition *)anotherCondition{
	self=[self init];
	[self setObject:[anotherCondition object]];
	[self setObject2:[anotherCondition object2]];
	[self setConditionTypeCode:[anotherCondition conditionTypeCode]];
	return self;
}

//アーカイブから初期化
- (id)initWithCoder:(NSCoder *)coder{
	[self setConditionTypeCode: [[coder decodeObject]intValue]];
	[self setObject:[coder decodeObject]];
	
	return self;
}
//アーカイブにエンコード
- (void)encodeWithCoder:(NSCoder *)coder{
	[coder encodeObject:[NSDecimalNumber numberWithInt:conditionTypeCode]];
	[coder encodeObject:object];
}

//accessors
- (void)setConditionTypeCode:(int)newConditionTypeCode{
	conditionTypeCode=newConditionTypeCode;
}
- (int)conditionTypeCode{
	return conditionTypeCode;
}
- (void)setObject:(id)newObject{
	[object autorelease];
	object=[newObject retain];
}
- (id)object{
	return object;
}
- (void)setObject2:(id)newObject2{
	[object2 autorelease];
	object2=[newObject2 retain];
}
- (id)object2{
	return object2;
}

//just get any book the smart book can be based on
- (Book *)getBook{
	return nil;
}

- (Condition *)copy{
	Condition *newCond=[[Condition alloc]init];
	[newCond setObject:object];
	[newCond setObject2:object2];
	[newCond setConditionTypeCode:conditionTypeCode];
	return newCond;
}

//IO matches condition
- (BOOL)ioMatchesCondition:(IO *)record{
	return YES;
}

- (BOOL)standardComparison:(id)recordObject{
	NSComparisonResult result=[object compare:recordObject];
	switch(conditionTypeCode){
		case kCondition_is:
			return result==NSOrderedSame;
		case kCondition_isnt:
			return result!=NSOrderedSame;
		case kCondition_biggerThan:
			return result==NSOrderedAscending;
		case kCondition_smallerThan:
			return result==NSOrderedDescending;
		case kCondition_between:
		case kCondition_notBetween:
		{//[object2 compare:recordObject];
			BOOL finalResult;
			finalResult=(result!=NSOrderedDescending) && ([object2 compare:recordObject]!=NSOrderedAscending);
			if(conditionTypeCode==kCondition_between)
				return finalResult;
			else
				return !finalResult;
		}
	}
	return NO;
}

- (ConditionView *)conditionView{
	return [[ConditionView alloc]initWithFrame:NSMakeRect(0,0,0,0)];
}
@end
