//
//  ConditionBox.m
//  iBal2
//
//  Created by Ken Kawamoto on Fri Aug 27 2004.
//  Copyright (c) 2004 AngryFish. All rights reserved.
//

#import "ConditionBox.h"
#import "ConditionView.h"
#import "FlippedView.h"

@implementation ConditionBox

- (id)init{
	self=[super initWithFrame:NSMakeRect(0,0,100,900)];
	
	[super setTitlePosition:NSNoTitle];
	[super setBoxType:NSBoxPrimary];
	
	//create a flipped view for content view
	[self setContentView:[[FlippedView alloc]initWithFrame:NSMakeRect(0,0,0,0)]];

	[self sizeToFit];
	
	return self;
}

- (void)addSubview:(NSView *)view{
	[self addSubview:view withDraw:YES];
}

- (void)addSubview:(NSView *)view withDraw:(BOOL)doDraw{
	[[self contentView]addSubview:view];
	if(doDraw)
		[self sizeToFit];
}

- (void)replaceSubview:(NSView *)aView with:(NSView *)anotherView{
	[self replaceSubview:aView with:anotherView withDraw:YES];
}

- (void)replaceSubview:(NSView *)aView with:(NSView *)anotherView withDraw:(BOOL)doDraw{
	[[self contentView] replaceSubview:aView with:anotherView];
	if(doDraw)
		[self sizeToFit];
}

//shrink fit
- (void)sizeToFit{
	NSArray *subviews=[[self contentView] subviews];
	int i,max=[subviews count]-1;
	float maxX=0,prevY=0,temp;
	NSRect bounds={{NULL},{NULL}};
	NSView *view;
	
	//set the x coordinates of the components, align middle
	for(i=0;i<=max;i++){
		view=[subviews objectAtIndex:i];

		bounds=[view bounds];
		bounds.origin=NSMakePoint(kHorizontalSpacing,prevY+kVerticalSpacing);
		[view setFrame:bounds];
		if(maxX<(temp=bounds.origin.x+bounds.size.width))
			maxX=temp;
		prevY=bounds.origin.y+bounds.size.height;
	}
	
	//set the frame
	bounds.origin=[self bounds].origin;
	bounds.size=NSMakeSize(maxX+kHorizontalSpacing,prevY+kVerticalSpacing);
	[self setFrameFromContentFrame:bounds];
	
	//tell the upper views of change in size
	[[self superview] sizeToFit];
}

//is the only condition
- (BOOL)isOnlyCondition{
	return [[self superview]isOnlyCondition];
}

@end
