//
//  ConditionControlBox.m
//  iBal2
//
//  Created by Ken Kawamoto on Sun Aug 29 2004.
//  Copyright (c) 2004 AngryFish. All rights reserved.
//

#import "ConditionControlBox.h"
#import "ConditionView.h"
#import "AndConditionView.h"
#import "OrConditionView.h"
#import "ConditionEditWindowController.h"

@implementation ConditionControlBox

- (id)initWithParent:(ConditionView *)newParent{
	self=[super initWithFrame:NSMakeRect(0,0,0,0)];
	
	parent=newParent;
	
	//set myself up
	{
		[self setBorderType:NSNoBorder];
		[self setTitlePosition:NSNoTitle];
	}
	
	//set up buttons
	andButton=orButton=deleteButton=nil;
	[self refreshButtons];
	
	return self;
}

- (void)refreshButtons{
	//and button
	BOOL isAnd=[parent isMemberOfClass:[AndConditionView class]];
	if(!andButton && !isAnd){
		andButton=[[NSButton alloc]initWithFrame:NSMakeRect(0,0,0,0)];
		[andButton setTitle:@" & "];
		[andButton setBezelStyle:NSTexturedSquareBezelStyle];
		[andButton sizeToFit];
		[self addSubview:andButton];
		[andButton setTarget:parent];
		[andButton setAction:@selector(addAnd:)];
	}
	else if(andButton && isAnd){
		[andButton removeFromSuperview];
		andButton=nil;
	}
	
	//or button
	BOOL isOr=[parent isMemberOfClass:[OrConditionView class]];
	if(!orButton && !isOr){
		orButton=[[NSButton alloc]initWithFrame:NSMakeRect(0,0,0,0)];
		[orButton setTitle:@" / "];
		[orButton setBezelStyle:NSTexturedSquareBezelStyle];
		[orButton sizeToFit];
		[self addSubview:orButton];
		[orButton setTarget:parent];
		[orButton setAction:@selector(addOr:)];
	}
	else if(orButton && isOr){
		[orButton removeFromSuperview];
		orButton=nil;
	}
	
	//delete button
	//BOOL isOnly=(BOOL)[[[ConditionEditWindowController sharedConditionEditWindowController] rootView]onlyOneCondition];
	BOOL isOnly=(([[parent superConditionView]isRoot]) && ([[[parent superConditionView]children]count]==1));
	if(!deleteButton && !isOnly){
		deleteButton=[[NSButton alloc]initWithFrame:NSMakeRect(0,0,0,0)];
		[deleteButton setTitle:@" - "];
		[deleteButton setBezelStyle:NSTexturedSquareBezelStyle];
		[deleteButton sizeToFit];
		[self addSubview:deleteButton];
		[deleteButton setTarget:parent];
		[deleteButton setAction:@selector(deleteParent:)];
	}
	else if(deleteButton && isOnly){
		[deleteButton removeFromSuperview];
		deleteButton=nil;
	}
	
	[self sizeToFit];
}

- (void)sizeToFit{
	float xPosition=0;
	if(andButton){
		[andButton setFrameOrigin:NSMakePoint(xPosition,0)];
		xPosition+=[andButton frame].size.width+kHorizontalSpacingBetweenButtons;
	}
	if(orButton){
		[orButton setFrameOrigin:NSMakePoint(xPosition,0)];
		xPosition+=[orButton frame].size.width+kHorizontalSpacingBetweenButtons;
	}
	if(deleteButton){
		[deleteButton setFrameOrigin:NSMakePoint(xPosition,0)];
	}
	
	[super sizeToFit];
	
	[[self superview]sizeToFit];
}


@end
