//
//  ConditionEditWindowController.m
//  iBal2
//
//  Created by Ken Kawamoto on Tue Aug 24 2004.
//  Copyright (c) 2004 AngryFish. All rights reserved.
//

#import "ConditionEditWindowController.h"
#import "SmartBook.h"
#import "iBalApp.h"
#import "ConditionView.h"
#import "AndConditionView.h"
#import "OrConditionView.h"
#import "AmountConditionView.h"

@implementation ConditionEditWindowController

- (id)init{
    self=[self initWithWindowNibName:@"ConditionEditWindow"];
    [self setWindowFrameAutosaveName:@"ConditionEditWindow"];
	
	dataRoot=[NSApp dataRoot];
	rootView=nil;
	
    return self;
}

//共有インスタンス
+ (id)sharedConditionEditWindowController{
    static ConditionEditWindowController *sharedConditionEditWindowController=nil;
    
    if(!sharedConditionEditWindowController)
        sharedConditionEditWindowController=[[ConditionEditWindowController allocWithZone:[self zone]]init];
    return sharedConditionEditWindowController;
}

- (void)editSmartPlaylist:(SmartBook *)book{
	currentBook=book;
}

- (void)openWindowAsSheetOf:(NSWindow *)aWindow{
	NSWindow *theWindow=[self window];
	if(![theWindow isVisible]){
		
		//innitialize root view
		[self setRootUsingSmartBook];
		
		[NSApp  beginSheet: theWindow
			modalForWindow: aWindow
			 modalDelegate: nil
			didEndSelector: nil
			   contextInfo: nil];
		
		[NSApp runModalForWindow: theWindow];
		
		[NSApp endSheet: theWindow];
		[theWindow orderOut: self];
		
		//kill condition view
		{
			[rootView removeFromSuperview];
			[rootView autorelease];
			rootView=nil;
		}
	}
}

- (IBAction)okClicked:(id)sender{
	//if there are not problems, stop the sheet
	if([self setConditionUsingRoot])
		[NSApp stopModal];
}

- (IBAction)cancelClicked:(id)sender{
	
	[NSApp stopModal];
}

- (ConditionView *)rootView{
	return rootView;
}
- (void)setRootView:(ConditionView *)newRootView{
	rootView=newRootView;
}

- (void)setRootAndViewWith:(ConditionView *)child{
	[rootView removeFromSuperview];
	rootView=[[AndConditionView alloc]initWithDraw:NO];
	[rootView setRoot:YES];
	[[[self window]contentView]addSubview:rootView];
	[rootView addSubview:child withDraw:NO];
	[child refreshControlBox];
}

- (void)setRootOrViewWith:(ConditionView *)child{
	[rootView removeFromSuperview];
	rootView=[[OrConditionView alloc]initWithDraw:NO];
	[rootView setRoot:YES];
	[[[self window]contentView]addSubview:rootView];
	[rootView addSubview:child withDraw:NO];
	[child refreshControlBox];
}

- (void)setRootUsingSmartBook{
	Condition *conditions=[currentBook conditions];
	if(conditions){
		rootView=[conditions conditionView];
		[rootView setRoot:YES];
		[[[self window]contentView]addSubview:rootView];
		[rootView sizeToFit];
		//[rootView addSubview:child withDraw:NO];
		//[child refreshControlBox];
	}
	else
		[self setRootAndViewWith:[[AmountConditionView alloc]init]];
}

- (BOOL)setConditionUsingRoot{
	Condition *condition=[rootView condition];
	if(condition){
		[currentBook setConditions:condition];
		return YES;
	}
	return NO;
}

@end
