//
//  DateCondition.h
//  iBal2
//
//  Created by Ken Kawamoto on Thu Aug 26 2004.
//  Copyright (c) 2004 AngryFish. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Condition.h"

@class IO;

enum PeriodID{
	kConditionPeriod_days=1,
	kConditionPeriod_weeks,
	kConditionPeriod_months
};

@interface DateCondition : Condition <NSCoding>{
	int periodID;
}

//アーカイブから初期化
- (id)initWithCoder:(NSCoder *)coder;
//アーカイブにエンコード
- (void)encodeWithCoder:(NSCoder *)coder;

- (void)setPeriodID:(int)newPeriodID;
- (int)periodID;

- (DateCondition *)copy;

//IO matches condition
- (BOOL)ioMatchesCondition:(IO *)record;

- (NSCalendarDate *)criticalDate;

- (ConditionView *)conditionView;

@end
