//
//  KeywordCondition.m
//  iBal2
//
//  Created by Ken Kawamoto on Thu Aug 26 2004.
//  Copyright (c) 2004 AngryFish. All rights reserved.
//

#import "KeywordCondition.h"
#import "IO.h"
#import "KeywordConditionView.h"

@implementation KeywordCondition

//アーカイブから初期化
- (id)initWithCoder:(NSCoder *)coder{
	[super initWithCoder:coder];
	
	return self;
}
//アーカイブにエンコード
- (void)encodeWithCoder:(NSCoder *)coder{
	[super encodeWithCoder:coder];
}


//IO matches condition
- (BOOL)ioMatchesCondition:(IO *)record{
	switch([super conditionTypeCode]){
		case kCondition_is:
			return [self checkIs:record];
		case kCondition_isnt:
			return ![self checkIs:record];
		case kCondition_includes:
			return [self checkIncludes:record];
		case kCondition_notInclude:
			return ![self checkIncludes:record];
	}
	return YES;
}

- (BOOL)checkIncludes:(IO *)record{
	return [record includesKeyword:[super object]];
}

- (BOOL)checkIs:(IO *)record{
	NSArray *keywords=[record keywords];
	return ([keywords count]==1 && [keywords objectAtIndex:0]==object);
}


- (ConditionView *)conditionView{
	KeywordConditionView *newView=[[KeywordConditionView alloc]init];
	
	//set the what ID
	[newView setWhatToID: conditionTypeCode];
	
	[newView setKeyword:object];
	
	return newView;
}

@end
